<template>
  <section class="user-text-default">
    <form v-on:submit.prevent="save" name="form-user-settings">
      <div class="form-ui-style-default">
        <div class="form-group">
          <label for="name">ФИО <i class="requred">*</i></label>
          <div>
            <input
                type="text"
                class="form-control"
                v-model="form.name"
            />
          </div>
        </div>

        <div class="form-group">
          <label for="birthday">Дата рождения</label>
          <div>
            <input
                type="text"
                v-model="form.birthday"
                @input="formatDate"
                class="form-control"
                placeholder="день/месяц/год"
            />
          </div>
        </div>

        <div class="form-group">
          <div class="form-check-inline">
            <input
                type="radio"
                class="form-check-input"
                v-model="form.sex"
                value="M"
                name="sex"
            />
            <label for="email" class="form-check-label">Мужчина</label>
          </div>
        </div>

        <div class="form-group">
          <div class="form-check-inline">
            <input
                type="radio"
                class="form-check-input"
                v-model="form.sex"
                value="W"
                name="sex"
            />
            <label for="email" class="form-check-label">Женщина</label>
          </div>
        </div>

        <div class="form-group">
          <label for="">Email</label>
          <input
              class="form-control"
              v-model="form.email"
          />
        </div>

        <div v-if="!cUser.email_verified_at && cUser.email" class="form-validation-errors alert alert-danger">
          <div>
            Подтвердите адрес Вашей почты. Мы отправили Вам письмо, проверьте свою почту.
          </div>
        </div>

        <div v-if="errors.length" class="form-validation-errors alert alert-danger">
          <div v-for="error in errors">
            {{ error }}
          </div>
        </div>

        <div class="form-group">
          <div class="d-flex justify-content-between form__buttons align-items-center">
            <button type="submit" class="btn btn-primary">
              Сохранить
            </button>
          </div>
        </div>
      </div>
    </form>
  </section>
</template>

<script>

import moment from "moment";

export default {
  props: {
    user: Object,
  },
  data() {
    return {
      cUser: this.user,
      form: {
        email: this.user.email,
        sex: this.user.sex,
        name: this.user.name,
        birthday: moment(this.user.birthday, null, 'fr').format('L'),
      },
      errors: [],
    }
  },
  methods: {
    updateUser(user) {
      this.cUser = user;
      this.$emit('user', this.cUser);
    },
    async save() {
      this.errors = [];
      await axios
          .post('/profile/about-info/', this.form)
          .then(result => {
            this.updateUser(result.data.data.user);
            this.$root.showAlert('Личные данные успешно сохранены', '');
          })
          .catch(error => {
            if (error.response) {
              const responseErrors = error.response.data.data.errors;

              if (responseErrors) {
                for (let key in responseErrors) {
                  responseErrors[key].forEach((error) => {
                    this.errors.push(error);
                  });
                }
              }
            }
          })
      ;
    },
    formatDate() {
      let cleanedInput = event.target.value.replace(/\D/g, '');

      if (cleanedInput.length <= 2) {
        this.form.birthday = cleanedInput;
      } else if (cleanedInput.length <= 4) {
        const day = cleanedInput.slice(0, 2);

        if (day > 31) {
          this.form.birthday = '';
        } else {
          this.form.birthday = day + '/' + cleanedInput.slice(2);
        }
      } else {
        const month = cleanedInput.slice(2, 4);

        if (month > 12 || month === '00') {
          this.form.birthday = cleanedInput.slice(0, 2);
        } else {
          const year = cleanedInput.slice(4, 8);

          if (year > new Date().getFullYear()) {
            this.form.birthday = cleanedInput.slice(0, 2) + '/' + cleanedInput.slice(2, 4);
          } else {
            this.form.birthday = cleanedInput.slice(0, 2) + '/' + cleanedInput.slice(2, 4) + '/' + cleanedInput.slice(4, 8);
          }
        }
      }
    },
  },
}
</script>
